searchData={"items":[{"type":"module","title":"Chorex","doc":"Main projector for choreographies.","ref":"Chorex.html"},{"type":"function","title":"Chorex.actor_from_local_exp/2","doc":"Get the actor name from an expression\n\n    iex> Chorex.actor_from_local_exp((quote do: Foo.bar(42)), __ENV__)\n    {:ok, Foo}","ref":"Chorex.html#actor_from_local_exp/2"},{"type":"function","title":"Chorex.cont_or_return/3","doc":"","ref":"Chorex.html#cont_or_return/3"},{"type":"macro","title":"Chorex.defchor/2","doc":"Define a new choreography.\n\nSee the documentation for the `Chorex` module for more details.","ref":"Chorex.html#defchor/2"},{"type":"function","title":"Chorex.do_local_project_wrapper/5","doc":"","ref":"Chorex.html#do_local_project_wrapper/5"},{"type":"function","title":"Chorex.empty_cont?/2","doc":"True if the continuation for the given code is empty. This can be\nfrom an empty block, or because the projection of block does\nnothing meaningful.","ref":"Chorex.html#empty_cont?/2"},{"type":"function","title":"Chorex.empty_ctx/2","doc":"","ref":"Chorex.html#empty_ctx/2"},{"type":"function","title":"Chorex.function_footer/1","doc":"","ref":"Chorex.html#function_footer/1"},{"type":"function","title":"Chorex.function_footer_continue/2","doc":"","ref":"Chorex.html#function_footer_continue/2"},{"type":"function","title":"Chorex.function_header/1","doc":"","ref":"Chorex.html#function_header/1"},{"type":"function","title":"Chorex.make_continue/1","doc":"","ref":"Chorex.html#make_continue/1"},{"type":"function","title":"Chorex.make_continue_function/3","doc":"","ref":"Chorex.html#make_continue_function/3"},{"type":"function","title":"Chorex.make_var_continue_function/4","doc":"","ref":"Chorex.html#make_var_continue_function/4"},{"type":"function","title":"Chorex.merge/2","doc":"Perform the control merge function.\n\nFlatten block expressions at each step: sometimes auxiliary blocks\nget created around bits of the projection; trim these out at this\nstep so equivalent expressions look equivalent.","ref":"Chorex.html#merge/2"},{"type":"function","title":"Chorex.merge_step/2","doc":"","ref":"Chorex.html#merge_step/2"},{"type":"function","title":"Chorex.metadata/1","doc":"","ref":"Chorex.html#metadata/1"},{"type":"function","title":"Chorex.proj_dbg/2","doc":"","ref":"Chorex.html#proj_dbg/2"},{"type":"function","title":"Chorex.project/4","doc":"Perform endpoint projection in the context of node `label`.\n\nThis returns a pair of a projection for the label, and a list of\nbehaviors that an implementer of the label must implement.\n\nArguments:\n\n1. Elixir AST term to project.\n2. Macro environment.\n3. Name of the actor currently under projection. Atom.\n4. Extra information about the expansion. Map. Contains:\n    - vars :: set of live variables\n    - actors :: list of all actor names\n\nReturns an instance of the `WriterMonad`, which is just a 3-tuple\ncontaining:\n\n1. The projected term. Elixir AST.\n2. A list of callback specifications for this actor. (Functions the\n   actor implementer needs to have.)\n3. List of auxiliary functions generated during the projection process.","ref":"Chorex.html#project/4"},{"type":"function","title":"Chorex.project_identifier/3","doc":"Project an expression like `Actor.var` to either `var` or `_`.\n\nProject to `var` when `Actor` matches the label we're projecting to,\nor `_` so that whatever data flows to that point can't be captured.","ref":"Chorex.html#project_identifier/3"},{"type":"function","title":"Chorex.project_local_expr/4","doc":"Project local expressions of the form `ActorName.(something)`.\n\nLike `project/4`, but focus on handling `ActorName.(local_var)`,\n`ActorName.local_func()` or `ActorName.(local_exp)`. Handles walking\nthe local expression to gather list of functions needed for the\nbehaviour to implement.","ref":"Chorex.html#project_local_expr/4"},{"type":"function","title":"Chorex.project_sequence/4","doc":"Project a sequence of expressions.","ref":"Chorex.html#project_sequence/4"},{"type":"function","title":"Chorex.push_stack/1","doc":"","ref":"Chorex.html#push_stack/1"},{"type":"function","title":"Chorex.splat_state/1","doc":"","ref":"Chorex.html#splat_state/1"},{"type":"function","title":"Chorex.start/3","doc":"Start a choreography.\n\nTakes a choreography module like `MyCoolThing.Chorex`, a map from\nactor names to implementing modules, and a list of arguments to pass\nto the `run` function.\n\nValues in the map are either modules or `remote_actor_ref()` tuples.","ref":"Chorex.html#start/3"},{"type":"function","title":"Example - Chorex.start/3","doc":"```elixir\nChorex.start(ThreePartySeller.Chorex,\n             %{ Buyer1 => MyBuyer1, Buyer2 => MyBuyer2, Seller => MySeller },\n             [])\n```","ref":"Chorex.html#start/3-example"},{"type":"function","title":"Chorex.tron/4","doc":"","ref":"Chorex.html#tron/4"},{"type":"function","title":"Chorex.tron/5","doc":"","ref":"Chorex.html#tron/5"},{"type":"function","title":"Chorex.unsplat_state/1","doc":"","ref":"Chorex.html#unsplat_state/1"},{"type":"function","title":"Chorex.walk_local_expr/4","doc":"Walks a local expression to pull out/convert function calls.\n\nThe `expr` in `Alice.(expr)` can *almost* be dropped directly into\nthe projection for the `Alice` node. Here's where that *almost*\ncomes in:\n\n - `Alice.(1 + foo())` needs to be rewritten as `1 + impl.foo()` and\n   `foo/0` needs to be added to the list of functions for the Alice\n   behaviour.\n\n - `Alice.some_func(&other_local_func/2)` needs to be rewritten as\n   `impl.some_func(&impl.other_local_func/2)` and both `some_func` and\n   `other_local_func` need to be added to the list of functions for the\n   Alice behaviour.\n\n - `Alice.(1 + Enum.sum(...))` should *not* be rewritten as `impl.…`.\n\nThere is some subtlety around tuples and function calls. Consider\nhow these expressions and their quoted representations compare:\n\n - `{:ok, foo}` → `{:ok, {:foo, [], …}}`\n\n - `{:ok, foo, bar}` → `{:{}, [], [:ok, {:foo, [], …}, {:bar, [], …}]}`\n\n - `ok(bar)` → `{:ok, [], [{:bar, [], …}]}`\n\nIt seems that 2-tuples have some special representation, which is frustrating.","ref":"Chorex.html#walk_local_expr/4"},{"type":"type","title":"Chorex.remote_actor_ref/0","doc":"A tuple describing where to find a remote host. The `Chorex.start/3`\nfunction takes this and spins up proxies as needed to manage the connection.\n\n```elixir\n{:remote, listen_socket :: integer(), remote_host :: binary(), remote_port :: integer()}\n```","ref":"Chorex.html#t:remote_actor_ref/0"},{"type":"module","title":"Chorex.Application","doc":"","ref":"Chorex.Application.html"},{"type":"function","title":"Chorex.Application.start/2","doc":"","ref":"Chorex.Application.html#start/2"},{"type":"module","title":"Chorex.Runtime","doc":"","ref":"Chorex.Runtime.html"},{"type":"macro","title":"Chorex.Runtime.chorex_send/4","doc":"","ref":"Chorex.Runtime.html#chorex_send/4"},{"type":"function","title":"Chorex.Runtime.continue_on_stack/2","doc":"Look at the top thing on the `RuntimeState` stack and return the\nproper response tuple.\n\nThis function gets called every time a function in the Chorex actor\nGenServer needs to finish.","ref":"Chorex.Runtime.html#continue_on_stack/2"},{"type":"macro","title":"Chorex.Runtime.correct_session/2","doc":"","ref":"Chorex.Runtime.html#correct_session/2"},{"type":"function","title":"Chorex.Runtime.handle_continue/2","doc":"","ref":"Chorex.Runtime.html#handle_continue/2"},{"type":"function","title":"Chorex.Runtime.handle_info/2","doc":"","ref":"Chorex.Runtime.html#handle_info/2"},{"type":"function","title":"Chorex.Runtime.init/1","doc":"","ref":"Chorex.Runtime.html#init/1"},{"type":"module","title":"Chorex.RuntimeMonitor","doc":"GenServer that monitors all actors in a choreography and attempts to\nrestart the system when something goes down.","ref":"Chorex.RuntimeMonitor.html"},{"type":"function","title":"Chorex.RuntimeMonitor.begin_checkpoint/2","doc":"","ref":"Chorex.RuntimeMonitor.html#begin_checkpoint/2"},{"type":"function","title":"Chorex.RuntimeMonitor.checkpoint_state/3","doc":"","ref":"Chorex.RuntimeMonitor.html#checkpoint_state/3"},{"type":"function","title":"Chorex.RuntimeMonitor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Chorex.RuntimeMonitor.html#child_spec/1"},{"type":"function","title":"Chorex.RuntimeMonitor.end_checkpoint/3","doc":"","ref":"Chorex.RuntimeMonitor.html#end_checkpoint/3"},{"type":"function","title":"Chorex.RuntimeMonitor.get_config_from_state/1","doc":"","ref":"Chorex.RuntimeMonitor.html#get_config_from_state/1"},{"type":"function","title":"Chorex.RuntimeMonitor.kickoff/2","doc":"","ref":"Chorex.RuntimeMonitor.html#kickoff/2"},{"type":"function","title":"Chorex.RuntimeMonitor.recover/3","doc":"Tell actor `name` at `pid` to recover with new network `new_config`.\n\nCalled for effect; no meaningful return value.","ref":"Chorex.RuntimeMonitor.html#recover/3"},{"type":"function","title":"Chorex.RuntimeMonitor.revive/2","doc":"Restore the actor that used to be at reference `ref`. Return the\nstate with an updated network configuration.","ref":"Chorex.RuntimeMonitor.html#revive/2"},{"type":"function","title":"Chorex.RuntimeMonitor.start_child/3","doc":"","ref":"Chorex.RuntimeMonitor.html#start_child/3"},{"type":"function","title":"Chorex.RuntimeMonitor.start_remote/3","doc":"","ref":"Chorex.RuntimeMonitor.html#start_remote/3"},{"type":"function","title":"Chorex.RuntimeMonitor.start_session/1","doc":"","ref":"Chorex.RuntimeMonitor.html#start_session/1"},{"type":"type","title":"Chorex.RuntimeMonitor.state/0","doc":"","ref":"Chorex.RuntimeMonitor.html#t:state/0"},{"type":"type","title":"Chorex.RuntimeMonitor.sync_token/0","doc":"","ref":"Chorex.RuntimeMonitor.html#t:sync_token/0"},{"type":"type","title":"Chorex.RuntimeMonitor.unwind_point/0","doc":"","ref":"Chorex.RuntimeMonitor.html#t:unwind_point/0"},{"type":"module","title":"Chorex.RuntimeState","doc":"","ref":"Chorex.RuntimeState.html"},{"type":"function","title":"Chorex.RuntimeState.ditch_recover_frame/1","doc":"Throw away the top frame, assuming it's a recover frame. If it's\nnot, raise an error.","ref":"Chorex.RuntimeState.html#ditch_recover_frame/1"},{"type":"function","title":"Chorex.RuntimeState.drop_inbox/2","doc":"","ref":"Chorex.RuntimeState.html#drop_inbox/2"},{"type":"function","title":"Chorex.RuntimeState.pop_to_recover_frame/1","doc":"Drop everything up to the first `recover` frame on the stack. Return\nthe recovery token as well as the state with the stack popped.","ref":"Chorex.RuntimeState.html#pop_to_recover_frame/1"},{"type":"function","title":"Chorex.RuntimeState.push_barrier_frame/2","doc":"","ref":"Chorex.RuntimeState.html#push_barrier_frame/2"},{"type":"function","title":"Chorex.RuntimeState.push_continue_frame/2","doc":"","ref":"Chorex.RuntimeState.html#push_continue_frame/2"},{"type":"function","title":"Chorex.RuntimeState.push_func_frame/2","doc":"","ref":"Chorex.RuntimeState.html#push_func_frame/2"},{"type":"function","title":"Chorex.RuntimeState.push_inbox/2","doc":"","ref":"Chorex.RuntimeState.html#push_inbox/2"},{"type":"function","title":"Chorex.RuntimeState.push_recover_frame/2","doc":"","ref":"Chorex.RuntimeState.html#push_recover_frame/2"},{"type":"function","title":"Chorex.RuntimeState.push_recv_frame/2","doc":"","ref":"Chorex.RuntimeState.html#push_recv_frame/2"},{"type":"function","title":"Chorex.RuntimeState.put_var/3","doc":"","ref":"Chorex.RuntimeState.html#put_var/3"},{"type":"type","title":"Chorex.RuntimeState.inbox_msg/0","doc":"An entry in the inbox looks like a CIV token × message payload","ref":"Chorex.RuntimeState.html#t:inbox_msg/0"},{"type":"type","title":"Chorex.RuntimeState.stack_frame/0","doc":"","ref":"Chorex.RuntimeState.html#t:stack_frame/0"},{"type":"type","title":"Chorex.RuntimeState.t/0","doc":"","ref":"Chorex.RuntimeState.html#t:t/0"},{"type":"type","title":"Chorex.RuntimeState.var_map/0","doc":"","ref":"Chorex.RuntimeState.html#t:var_map/0"},{"type":"module","title":"Chorex.RuntimeSupervisor","doc":"DynamicSupervisor for Chorex actors.","ref":"Chorex.RuntimeSupervisor.html"},{"type":"function","title":"Chorex.RuntimeSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Chorex.RuntimeSupervisor.html#child_spec/1"},{"type":"function","title":"Chorex.RuntimeSupervisor.start_child/3","doc":"","ref":"Chorex.RuntimeSupervisor.html#start_child/3"},{"type":"function","title":"Chorex.RuntimeSupervisor.start_link/1","doc":"","ref":"Chorex.RuntimeSupervisor.html#start_link/1"},{"type":"module","title":"Chorex.SocketListener","doc":"","ref":"Chorex.SocketListener.html"},{"type":"function","title":"Chorex.SocketListener.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Chorex.SocketListener.html#child_spec/1"},{"type":"function","title":"Chorex.SocketListener.init/1","doc":"","ref":"Chorex.SocketListener.html#init/1"},{"type":"function","title":"Chorex.SocketListener.listen/1","doc":"","ref":"Chorex.SocketListener.html#listen/1"},{"type":"module","title":"Chorex.SocketProxy","doc":"Socket proxy","ref":"Chorex.SocketProxy.html"},{"type":"function","title":"Chorex.SocketProxy.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Chorex.SocketProxy.html#child_spec/1"},{"type":"function","title":"Chorex.SocketProxy.init/1","doc":"","ref":"Chorex.SocketProxy.html#init/1"},{"type":"function","title":"Chorex.SocketProxy.schedule_send/0","doc":"","ref":"Chorex.SocketProxy.html#schedule_send/0"},{"type":"function","title":"Chorex.SocketProxy.schedule_send/1","doc":"","ref":"Chorex.SocketProxy.html#schedule_send/1"},{"type":"function","title":"Chorex.SocketProxy.send_until_empty/1","doc":"","ref":"Chorex.SocketProxy.html#send_until_empty/1"},{"type":"type","title":"Chorex.SocketProxy.config_map/0","doc":"","ref":"Chorex.SocketProxy.html#t:config_map/0"},{"type":"type","title":"Chorex.SocketProxy.state/0","doc":"","ref":"Chorex.SocketProxy.html#t:state/0"},{"type":"module","title":"Chorex.Types","doc":"","ref":"Chorex.Types.html"},{"type":"type","title":"Chorex.Types.chorex_message/0","doc":"A chorex message looks like the atom `:chorex`, a `civ_tok()`, and a payload","ref":"Chorex.Types.html#t:chorex_message/0"},{"type":"type","title":"Chorex.Types.civ_tok/0","doc":"A CIV token is a string (UUID) indicating the session, the line\n  information identifying the message, the sender name, and the\n  receiver name.","ref":"Chorex.Types.html#t:civ_tok/0"},{"type":"type","title":"Chorex.Types.session_token/0","doc":"","ref":"Chorex.Types.html#t:session_token/0"},{"type":"module","title":"FreeVarAnalysis","doc":"Free variable analysis for Elixir expressions","ref":"FreeVarAnalysis.html"},{"type":"function","title":"FreeVarAnalysis.all_vars/1","doc":"Collect all variables mentioned in some syntax, free or otherwise.\n\niex> all_vars(quote do: x) |> Enum.map(&elem(&1, 0))\n[:x]\niex> all_vars(quote do: fn x -> x + 1 end) |> Enum.map(&elem(&1, 0))\n[:x]\niex> all_vars(quote do: fn x -> x + y end) |> Enum.map(&elem(&1, 0))\n[:x, :y]","ref":"FreeVarAnalysis.html#all_vars/1"},{"type":"function","title":"FreeVarAnalysis.extract_new_pattern_var_names/2","doc":"","ref":"FreeVarAnalysis.html#extract_new_pattern_var_names/2"},{"type":"function","title":"FreeVarAnalysis.extract_pattern_vars/2","doc":"","ref":"FreeVarAnalysis.html#extract_pattern_vars/2"},{"type":"function","title":"FreeVarAnalysis.free_vars/2","doc":"Return all variables that are *free* in an expression.\n\niex> free_vars(quote do: fn x -> {^x, ^y, _} = {1, 2, 3} end) |> Enum.map(&elem(&1, 0))\n[:y]","ref":"FreeVarAnalysis.html#free_vars/2"},{"type":"macro","title":"FreeVarAnalysis.is_var/1","doc":"","ref":"FreeVarAnalysis.html#is_var/1"},{"type":"function","title":"FreeVarAnalysis.is_var?/1","doc":"","ref":"FreeVarAnalysis.html#is_var?/1"},{"type":"function","title":"FreeVarAnalysis.var_name/1","doc":"","ref":"FreeVarAnalysis.html#var_name/1"},{"type":"type","title":"FreeVarAnalysis.ast/0","doc":"","ref":"FreeVarAnalysis.html#t:ast/0"},{"type":"type","title":"FreeVarAnalysis.full_var/0","doc":"","ref":"FreeVarAnalysis.html#t:full_var/0"},{"type":"module","title":"Utils","doc":"","ref":"Utils.html"},{"type":"function","title":"Utils.count_barriers/1","doc":"","ref":"Utils.html#count_barriers/1"},{"type":"function","title":"Utils.downcase_atom/1","doc":"iex> Utils.downcase_atom(Foo)\n:foo","ref":"Utils.html#downcase_atom/1"},{"type":"function","title":"Utils.fresh_atom/1","doc":"","ref":"Utils.html#fresh_atom/1"},{"type":"function","title":"Utils.upcase_atom/1","doc":"iex> Utils.upcase_atom(:foo)\n:Foo","ref":"Utils.html#upcase_atom/1"},{"type":"module","title":"WriterMonad","doc":"Makes it easy to do operations on code and track gathered data.","ref":"WriterMonad.html"},{"type":"function","title":"WriterMonad.<~>/2","doc":"","ref":"WriterMonad.html#%3C~%3E/2"},{"type":"function","title":"WriterMonad.bind/2","doc":"","ref":"WriterMonad.html#bind/2"},{"type":"function","title":"WriterMonad.flatten_block/1","doc":"Flatten nested block expressions as much as possible.\n\nTurn something like\n\n```elixir\ndo\n  do\n    …\n  end\nend\n```\n\ninto simply\n\n```elixir\ndo\n  …\n  end\n```\n\nThis is important for the `merge/2` function to be able to tell when\ntwo expressions are equivalent.","ref":"WriterMonad.html#flatten_block/1"},{"type":"function","title":"WriterMonad.fmap/2","doc":"","ref":"WriterMonad.html#fmap/2"},{"type":"function","title":"WriterMonad.fromEmpyWriter/1","doc":"","ref":"WriterMonad.html#fromEmpyWriter/1"},{"type":"function","title":"WriterMonad.mapM/2","doc":"","ref":"WriterMonad.html#mapM/2"},{"type":"macro","title":"WriterMonad.monadic/1","doc":"Haskell-like `do` notation for monads.\n\niex> import WriterMonad\niex> monadic do\n...>   thing1 <- return(5)\n...>   thing2 <- {thing1 + 2, [\"foo\"], [:zoop]}\n...>   thing3 <- {thing1 + thing2, [\"bar\"], [:quux]}\n...>   return thing3\n...> end\n{12, [\"bar\", \"foo\"], [:zoop, :quux]}","ref":"WriterMonad.html#monadic/1"},{"type":"function","title":"WriterMonad.mt/0","doc":"","ref":"WriterMonad.html#mt/0"},{"type":"function","title":"WriterMonad.mzero/0","doc":"","ref":"WriterMonad.html#mzero/0"},{"type":"function","title":"WriterMonad.return/1","doc":"","ref":"WriterMonad.html#return/1"},{"type":"function","title":"WriterMonad.return/2","doc":"","ref":"WriterMonad.html#return/2"},{"type":"function","title":"WriterMonad.return/3","doc":"","ref":"WriterMonad.html#return/3"},{"type":"function","title":"WriterMonad.return_func/1","doc":"","ref":"WriterMonad.html#return_func/1"},{"type":"function","title":"WriterMonad.return_func/2","doc":"","ref":"WriterMonad.html#return_func/2"},{"type":"function","title":"WriterMonad.~>>/2","doc":"","ref":"WriterMonad.html#~%3E%3E/2"},{"type":"type","title":"WriterMonad.t/0","doc":"{expression, [callback_spec], [fresh_functions]}","ref":"WriterMonad.html#t:t/0"},{"type":"exception","title":"Chorex.CommunicationIntegrity","doc":"","ref":"Chorex.CommunicationIntegrity.html"},{"type":"exception","title":"Chorex.ProjectionError","doc":"","ref":"Chorex.ProjectionError.html"},{"type":"extras","title":"README","doc":"Chorex - Choreographic Programming in Elixir\n\n[![Chorex Tests](https://github.com/utahplt/chorex/actions/workflows/elixir.yml/badge.svg)](https://github.com/utahplt/chorex/actions/workflows/elixir.yml)\n\n# Synopsis\n\n**Note:** this documentation is current as of 2025-02-24. The project is evolving rapidly, so this README may occasionally get out-of-sync with what the project can do.\n\nAdd `Chorex.Registry` to your application setup:\n\n```elixir\n# part of application startup; e.g. in a Phoenix application this\n# would be in MyApp.Application located at lib/my_app/application.ex\nchildren = [\n  {Registry, name: Chorex.Registry, keys: :unique}\n]\n```\n\nDescribe the choreography in a module with the `defchor` macro:\n\n```elixir\ndefmodule TestChor do\n  defchor [Buyer, Seller] do\n    def run(Buyer.(book_title)) do\n      Buyer.(book_title) ~> Seller.(b)\n      Seller.get_price(b) ~> Buyer.(p)\n      Buyer.(p)\n    end\n  end\nend\n```\n\nImplement the actors:\n\n```elixir\ndefmodule MyBuyer do\n  use TestChor.Chorex, :buyer\nend\n\ndefmodule MySeller do\n  use TestChor.Chorex, :seller\n\n  def get_price(\"Das Glasperlenspiel\"), do: 42\n  def get_price(\"A Tale of Two Cities\"), do: 16\nend\n```\n\nElsewhere in your program:\n\n```elixir\nChorex.start(TestChor.Chorex, %{Seller => MySeller, Buyer => MyBuyer}, [\"Das Glasperlenspiel\"])\n\nreceive do\n  {:chorex_return, Buyer, val} ->\n    IO.puts(\"Got #{val}\")            # prints \"Got 42\"\nend\n\nChorex.start(TestChor.Chorex, %{Seller => MySeller, Buyer => MyBuyer}, [\"A Tale of Two Cities\"])\n\nreceive do\n  {:chorex_return, Buyer, val} ->\n    IO.puts(\"Got #{val}\")            # prints \"Got 16\"\nend\n```\n\n# Description\n\nChorex is a library for *choreographic programming* in Elixir. Choreographic programming is a programming paradigm where you specify the interactions between different entities in a concurrent system in one global view, and then *extract implementations* for each of those actors. See [§ Bibliography](#org44e5aee) for references on choreographic programming in general.","ref":"readme.html"},{"type":"extras","title":"Installation - README","doc":"Chorex is available on Hex.pm. Install by including the following in your `mix.exs` file under the `deps` list:\n\n```elixir\ndef deps do\n  [\n    ...,\n    {:chorex, \"~> 0.8.0\"},\n    ...\n  ]\nend\n```\n\nYou can install development versions of Chorex directly from GitHub like so:\n\n```elixir\ndef deps do\n  [\n    ...,\n    {:chorex, github: \"utahplt/chorex\"},\n    ...\n  ]\nend\n```\n\nAdd `Chorex.Registry` to your application setup:\n\n```elixir\n# part of application startup; e.g. in a Phoenix application this\n# would be in MyApp.Application located at lib/my_app/application.ex\nchildren = [\n  {Registry, name: Chorex.Registry, keys: :unique}\n]\n```\n\nNote that this is *experimental software* and stuff *will* break. Please don't rely on this for anything production-grade. Not yet at least.","ref":"readme.html#installation"},{"type":"extras","title":"What is a choreography? - README","doc":"A choreography is a birds-eye view of an interaction between nodes in a distributed system. You have some set of *actors*—in Elixir parlance processes—that exchange *messages* while also running some *local computation*—i.e. functions that don't rely on talking to other nodes in the system.\n\nLindsey Kuper's research group has put together [a delightful zine explaining choreographic programming](https://decomposition.al/zines/#communicating-chorrectly-with-a-choreography). Check that out if you are new to choreographies.\n\nAt a high-level, Chorex lets you build choreographies to describe different interactions between components of your system. Chorex focuses on the communication flow; you still implement the computation that runs locally on each node, but you don't have to worry about writing `send`s between nodes.\n\n<!-- FIXME: link the examples repo here -->\nOnce you have a choreography, you can *instantiate* it any number of times as you like. You might want, for example, to have one choreography describing how a user actor would communicate to create an account on a system, and then another choreography for how an existing user would log in with previously established credentials.","ref":"readme.html#what-is-a-choreography"},{"type":"extras","title":"Choreography syntax - README","doc":"Chorex introduces some new Elixir syntax for choreographies. Here's a breakdown of how it works.\n\nStart by creating a module to hold the choreography, say `import Chorex`, and add a `defchor` block:\n\n```elixir\ndefmodule MyCoolChoreography do\n  import Chorex\n\n  defchor [Actor1, Actor2, ...] do\n    ...choreography body...\n  end\nend\n```\n\n(Note: in addition to the choreography definition here, you will need to make a module for each actor. We'll focus on the special syntax of the `defchor` block in this section, but later you'll see how to built a module for each of the `Actor1`, `Actor2`, etc.)\n\nThe `defchor` macro wraps a choreography and translates it into core Elixir code. You give `defchor` a list of actors, specified as if they were module names, and then a `do` block wraps the choreography body.\n\nThe body of the choreography is a set of functions. One function named `run` must be present: this serves as the entry point into the choreography. The arguments to `run` come from the third argument to the `Chorex.start` function and are how you typically get values into an instantiation of a choreography. (More on `Chorex.start` and function parameters in a minute.)\n\n```elixir\ndefchor [Actor1, Actor2, ...] do\n  def some_func(...) do\n    ...\n  end\n\n  def run() do\n    ...\n  end\nend\n```","ref":"readme.html#choreography-syntax"},{"type":"extras","title":"Message passing expressions - README","doc":"Inside the body of functions you can write message passing expressions. Examples:\n\n```elixir\nActor1.(var1) ~> Actor2.(var2_a)\nActor1.func_1() ~> Actor2.(var2_b)\nActor1.func_2(var1_a, var1_b) ~> Actor2.(var2_c)\nActor1.(var1_a + var1_b) ~> Actor2.(var2_c)\n```\n\nFormal syntax:\n\n```bnf\n  message_pass ::= $local_exp ~> $actor.($pat)\n\n  local_exp    ::= $actor.($pat)\n                 | $actor.$func($exp, ...)\n                 | $actor.($exp)\n\n  actor        ::= Module name         (e.g. Actor)\n  func         ::= Function name       (e.g. frobnicate(...))\n  pat          ::= Pattern match expr  (e.g. a variable like `foo` or tuples `{:ok, bar}` etc.)\n  exp          ::= Elixir expression   (e.g. foo + sum([1, 2, 3]))\n```\n\nThe `~>` indicates sending a message between actors. The left-hand-side must be `Actor1. `, where that ` ` bit can be one of three things:\n\n1.  A variable local to Actor1\n2.  A function local to Actor1 (with or without arguments, also all local to Actor1)\n3.  An expression local to Actor1\n\nThe right-and-side must be `Actor2.( )`. This means that the left-hand-side will be computed on `Actor1` and send to `Actor2` where it will be matched against the pattern `pattern`.","ref":"readme.html#message-passing-expressions"},{"type":"extras","title":"Local expressions - README","doc":"*Local expressions* are computations that happen on a single node. These computations are isolated from each other—i.e. every location has its own variables. For example, if I say:\n\n```elixir\ndefchor [Holmes, Watson] do\n  def discombobulate(Holmes.(clue)) do\n    ...\n  end\nend\n```\n\nThen inside the body of that function, I can talk about the variable `clue` which is located on the `Holmes` node. I can't, for instance, talk about the variable `clue` on the `Watson` node.\n\n```elixir\nHolmes.(clue + 1)    # fine\nWatson.(clue * 2)    # error: variable `clue` not defined\n```\n\nI can *send* the value in Holmes' `clue` variable to Watson, at which point Watson can do computation with the value:\n\n```elixir\nHolmes.(clue) ~> Watson.(holmes_observes)\n\nif Watson.remember(holmes_observes) do\n  ...\nelse\n  ...\nend\n```\n\nThe `remember` function here will be defined on the the implementation for the `Watson` actor.\n\n**ACHTUNG!! `mix format` will rewrite `Actor1.var1` to `Actor1.var1()` which is a function call instead of a variable! Wrap variables in parens like `Actor1.(var1)` if you want to use `mix format`!** This is an unfortunate drawback—suggestions on fixing this would be welcome.\n\nLocal functions are not defined as part of the choreography; instead, you implement these in a separate Elixir module. More on that later.\n\n\n### `if` expressions and knowledge of choice broadcasting\n\n```elixir\nif Actor1.make_decision(), notify: [Actor2] do\n  ...\nelse\n  ...\nend\n```\n\n`if` expressions are supported. Some actor makes a choice of which branch to go down. It is then *crucial* that that deciding actor inform all other actors about the choice of branch with the special `notify: [Actor2, Actor3, ...]` syntax. If this is omitted, *all* actors will be informed, which may lead to more messages being sent than necessary.","ref":"readme.html#local-expressions"},{"type":"extras","title":"Function syntax - README","doc":"```elixir\ndefchor [Alice, Bob] do\n  def run(Alice.(msg)) do\n    with Bob.({pub, priv}) <- Bob.gen_key() do\n      Bob.(pub) ~> Alice.(key)\n      exchange_message(Alice.encrypt(msg <> \"\\n  love, Alice\", key), Bob.(priv))\n    end\n  end\n\n  def exchange_message(Alice.(enc_msg), Bob.(priv)) do\n    Alice.(enc_msg) ~> Bob.(enc_msg)\n    Alice.(:letter_sent)\n    Bob.decrypt(enc_msg, priv)\n  end\nend\n```\n\nChoreographies support functions and function calls—even recursive ones. Function parameters need to be annotated with the actor they live at, and the arguments when calling the function need to match. Calling a function with the wrong actor will result in the parameter getting `nil`. E.g. calling `exchange_message` above like so will not work properly:\n\n```elixir\nexchange_message(Bob.(msg), Alice.(priv))\n```\n\n(and not just because the variables are wrong—the actor names don't match so the parameters won't get the values they need).","ref":"readme.html#function-syntax"},{"type":"extras","title":"Higher-order choreographies - README","doc":"```elixir\ndef higher_order_chor(other_chor) do\n  ... other_chor.(...) ...\nend\n```\n\nChorex supports higher-order choreographies. This means you can pass the functions defined *inside the `defchor` block* around as you would with functions. Higher-order choreographic functions *don't* get an actor prefix and you call them as you would a function bound to a variable, like so:\n\n```elixir\ndefchor [Actor, OtherActor] do\n  def higher_order_chor(other_chor) do\n    ... other_chor.(...) ...\n  end\n\n  def some_local_chor(Actor.(var_name)) do\n    Actor.(var_name) ~> OtherActor.(other_var)\n    OtherActor.(other_var)\n  end\n\n  def run() do\n    higher_order_chor(@some_local_chor/1)\n  end\nend\n```\n\nNote that when referring to the function, you **must** use the `@func_name/3` syntax—the Chorex compiler notices the `@` and processes the function reference differently. This is because the functions defined with `def` inside the `defchor` block have private internal details (when Chorex builds them, they get special implicit arguments added) and Chorex needs to handle references to these functions specially.","ref":"readme.html#higher-order-choreographies"},{"type":"extras","title":"Variable binding - README","doc":"```elixir\nwith OtherActor.(other_var) <- other_chor.(Actor.(var)) do\n  ...\nend\n```\n\nYou can bind the result of some expression to a variable/pattern at an actor with `with`. In the case of a higher-order choreography (seen above) this is whatever was on node `OtherActor` when `other_chor` executed. You may also use `with` for binding local expressions, as seen in the `exchange_message` example under § Function syntax.","ref":"readme.html#variable-binding"},{"type":"extras","title":"Error recovery - README","doc":"```elixir\ndefmodule Bookstore do\n  import Chorex\n\n  defchor [Buyer, Seller, Contributor] do\n    def run() do\n      Buyer.get_book_title() ~> Seller.(book)\n      Seller.get_price(book) ~> Buyer.(price)\n      Seller.get_price(book) ~> Contributor.(price)\n\n      try do\n        Contributor.compute_contribution(price) ~> Buyer.(extra_money) # might blow up\n\n        if Buyer.in_budget(price - extra_money) do\n          ...\n        else\n          ...\n        end\n      rescue\n        if Buyer.in_budget(price) do # no extra money!\n          Buyer.(\"thanks anyway\") ~> Contributor.(thank_you_note)\n          ...\n        else\n          ...\n        end\n      end\n    end\n  end\nend\n```\n\nChorex supports exceptions in the form of actors crashing. In the above example, suppose the function `compute_contribution` is known to possibly crash at runtime. In accordance with the Erlang/Elixir philosophy of \"let it crash\", suppose we would rather recover from this crash than harden the `Contributor` actor to prevent crashes.\n\nIn the case of a crash inside the `try` block, the crasher will get restarted, and all actors will abort execution of the `try` block and move to the `rescue` block.","ref":"readme.html#error-recovery"},{"type":"extras","title":"Creating a choreography: `defchor` + actor implementations - README","doc":"To create a choreography, start by making a module, and writing the choreography with the `defchor` macro.\n\n```elixir\ndefmodule Bookstore do\n  import Chorex\n\n  defchor [Actor1, Actor2] do\n    def run() do\n      Actor1.(... some expr ...) ~> Actor2.(some_var)\n      Actor2.some_computation(some_var) ~> Actor1.(the_result)\n      ...\n    end\n  end\nend\n```\n\nYou will need to make a module for every actor you specify at the beginning of `defchor` and mark which actor you're implementing like so:\n\n```elixir\ndefmodule MyFirstActor do\n  use Bookstore.Chorex, :actor1\n\n  ...\nend\n\ndefmodule MySecondActor do\n  use Bookstore.Chorex, :actor2\n\n  def some_computation(val), do: ...\nend\n```\n\nThese modules will need to implement all of the local functions specified in the choreography. Chorex will use Elixir's behaviour mechanism to warn you if you don't implement every function needed. In the above example, the `MySecondActor` implements the role of `Actor2` in the choreography, and therefore needs to implement the `some_computation` function.\n\n**Note:** *Actor names do not need to be the same as the modules implementing them!* It is *useful* to do that, but there exist instances where you might want to write one choreography and implement it in different ways.","ref":"readme.html#creating-a-choreography-defchor-actor-implementations"},{"type":"extras","title":"Running a choreography - README","doc":"You need three things to fire off a choreography:\n\n1. The choreography description\n2. An implementation for each of the actors\n3. A call to `Chorex.start`\n\nUse the `Chorex.start/3` function to start a choreography:\n\n```elixir\nChorex.start(MyChoreography.Chorex,\n             %{ Actor1 => MyActor1Impl,\n                Actor2 => MyActor2Impl },\n             [args, to, run])\n```\n\nThe arguments are as follows:\n\n 1. The name of the `Chorex` module to use. (The `defchor` macro creates this module for you; in the above example there is a `MyChoreography` module with a top-level `defchor` declaration that creates the `Chorex` submodule on expansion.)\n 2. A map from actor name to implementation module name.\n 3. A list of arguments to the `run` function in the Choreography. These will automatically get sent to the right nodes.\n\nOnce the actors are done, they will send the last value they computed to the current process tagged with the actor they were implementing. So, for this example, you could see what `Actor1` computed by awaiting:\n\n```elixir\nreceive do\n  {:chorex_return, Actor1, val} -> IO.inspect(val, label: \"Actor1's return: \")\nend\n```","ref":"readme.html#running-a-choreography"},{"type":"extras","title":"Using a choreography with the rest of your project - README","doc":"The local functions are free to call any other code you have—they're just normal Elixir. If that code sends and receives messages not managed by the choreography library, there is no guarantee that this will be deadlock-free.\n\n\n# Development\n\nChorex is under active development and things will change and break rapidly.\n\nIf you find any bugs or would like to suggest a feature, please [open an issue on GitHub](https://github.com/utahplt/chorex/issues).","ref":"readme.html#using-a-choreography-with-the-rest-of-your-project"},{"type":"extras","title":"Changelog - README","doc":"We will collect change descriptions here until we come up with a more stable format when changes get bigger.\n\n - v0.8.5, 2025-04-23\n \n   Fix a hidden bug in the fix for v0.8.3.\n\n - v0.8.4, 2025-04-15\n \n   Bug fix; typo\n\n - v0.8.3, 2025-04-11\n \n   Bug fix with certain `try/rescue` patterns; barrier tokens now include stack depth.\n\n - v0.8.2, 2025-02-28\n \n   Bug fix with some function parameters not making it into the context before `try/rescue` checkpoint.\n\n - v0.8.1, 2025-02-24\n \n   `with` blocks can be in non-tail position. Compile error on missing branch broadcast.\n\n - v0.8.0, 2025-02-10\n \n   Error recovery. 🎉 First-ever in a choreographic system! 🎉\n\n - v0.7.0, 2025-01-22\n \n   New runtime model.\n\n - v0.6.0, 2025-01-09\n \n   Big rewrite to project actors to GenServers under the hood.\n\n - v0.5.0, 2025-11-15\n \n   Protection against out-of-order messages with communication integrity tokens.\n\n - v0.4.3; 2024-08-13\n \n   Multi-clause `with` blocks work.\n\n - v0.4.2; 2024-08-07\n \n   Bugfix: projecting local expressions that call out to an Erlang module.\n\n - v0.4.1; 2024-08-01\n\n   Bugfix: choreographies can now have literal maps in local expressions.\n\n - v0.4.0; 2024-08-01\n \n   Functions can take arbitrary number of arguments from different actors.\n\n - v0.3.1; 2024-07-30\n\n   Fix many problems around local expression projection.\n\n - v0.3.0; 2024-07-22\n\n   Add `Chorex.start` and `run` function as an entry-point into the choreography.\n\n - v0.2.0; 2024-07-03\n\n   Add shared-state actors.\n\n - v0.1.0; 2024-05-30\n\n   Initial release. Lots of rough edges so please, be patient. :)","ref":"readme.html#changelog"},{"type":"extras","title":"High-level internals - README","doc":"The `defchor` macro is implemented in the `Chorex` module.\n\n-   The `defchor` macro gathers a list of actors.\n-   For each actor, call `project` on the body of the choreography. The `project` function keeps track of the current actor as the `label` variable. (This vernacular borrowed from the academic literature.)\n-   The functions `project` and `project_sequence` are mutually recursive: `project_sequence` gets invoked whenever `project` encounters a block with multiple instructions.\n-   The `project` function walks the AST, it gathers a list of functions that will need to be implemented by each actor's implementing module, as well as a list of top-level functions for each projection.\n    -   This gathering is handled by the `WriterMonad` module, which provides the `monadic do ... end` form as well as `return` and `mzero`.\n-   Finally the macro generates modules for each actor under the `Chorex` module it generates.\n\n\nEach actor projects to GenServer. The GenServer maintains some state at runtime: most importantly, it tracks the function call stack and an inbox of pending Chorex messages.","ref":"readme.html#high-level-internals"},{"type":"extras","title":"Testing - README","doc":"Simply clone the repository and run `mix test`.\n\n\n  \n\n# Bibliography\n\n-   Hirsch & Garg (2022-01-16) *Pirouette: Higher-Order Typed Functional Choreographies*, Proceedings of the ACM on Programming Languages.  \n\n-   Lugović & Montesi (2023-10-15) *Real-World Choreographic Programming: Full-Duplex Asynchrony and Interoperability*, The Art, Science, and Engineering of Programming.  \n\n\n# Authors\n\nThis is a project by the [Utah PLT](https://github.com/utahplt) group. Primary development by [Ashton Wiersdorf](https://lambdaland.org).","ref":"readme.html#testing"},{"type":"extras","title":"Documentation of Chorex Internals","doc":"Documentation of Chorex Internals\n=================================\n\nCompile time\n------------\n\nThe `Chorex` module manages actor projection.\n\n\nRuntime\n-------","ref":"internals.html"},{"type":"extras","title":"GenServer state - Documentation of Chorex Internals","doc":"An actor in a choreography is a GenServer. All actors are made by invoking `use Chorex.Runtime`. See that module for a description of the runtime state.","ref":"internals.html#genserver-state"},{"type":"extras","title":"Using Chorex","doc":"Using Chorex\n============\n\nMake your modules dance!\n\nChorex allows you to specify a choreography: a birds-eye view of an\ninteraction of concurrent parties. Chorex takes that choreography\ncreates a *projection* of that interaction for each party in the\nsystem.\n\nTake, for example, the classic problem of a book seller and two\nbuyers who want to split the price. The interaction looks like this:\n\n```\n+------+         +------+ +------+\n|Buyer1|         |Seller| |Buyer2|\n+--+---+         +--+---+ +--+---+\n   |                |        |\n   |   Book title   |        |\n   |--------------->|        |\n   |                |        |\n   |     Price      |        |\n   |<---------------|        |\n   |                |        |\n   |                |  Price |\n   |                |------->|\n   |                |        |\n   |      Contribution       |\n   |<------------------------|\n   |                |        |\n   |   Buy/No buy   |        |\n   |--------------->|        |\n   |                |        |\n   |(if Buy) address|        |\n   |--------------->|        |\n   |                |        |\n   | Shipping date  |        |\n   |<---------------|        |\n   |                |        |\n+--+---+         +--+---+ +--+---+\n|Buyer1|         |Seller| |Buyer2|\n+------+         +------+ +------+\n```\n\nYou can encode that interaction with the `defchor` macro and DSL:\n\n```elixir\ndefmodule ThreePartySeller do\n  defchor [Buyer1, Buyer2, Seller] do\n    def run() do\n      Buyer1.get_book_title() ~> Seller.(b)\n      Seller.get_price(\"book:\" <> b) ~> Buyer1.(p)\n      Seller.get_price(\"book:\" <> b) ~> Buyer2.(p)\n      Buyer2.compute_contrib(p) ~> Buyer1.(contrib)\n\n      if Buyer1.(p - contrib   Seller.(addr)\n        Seller.get_delivery_date(b, addr) ~> Buyer1.(d_date)\n        Buyer1.(d_date)\n      else\n        Buyer1.(nil)\n      end\n    end\n  end\nend\n```\n\nThe `defchor` macro will take care of generating code that handles\nsending messages. Now all you have to do is implement the local\nfunctions that don't worry about the outside system:\n\n```elixir\ndefmodule MySeller do\n  use ThreePartySeller.Chorex, :seller\n\n  def get_price(book_name), do: ...\n  def get_delivery_date(book_name, addr), do: ...\nend\n\ndefmodule MyBuyer1 do\n  use ThreePartySeller.Chorex, :buyer1\n\n  def get_book_title(), do: ...\n  def get_address(), do: ...\n  def get_budget(), do: ...\nend\n\ndefmodule MyBuyer2 do\n  use ThreePartySeller.Chorex, :buyer2\n\n  def compute_contrib(price), do: ...\nend\n```\n\nWhat the `defchor` macro actually does is creates a module `Chorex`\nand submodules for each of the actors: `Chorex.Buyer1`,\n`Chorex.Buyer2` and `Chorex.Seller`. There's a handy `__using__`\nmacro that will Do the right thing when you say `use Mod.Chorex, :actor_name`\nand will import those modules and say that your module implements\nthe associated behaviour. That way, you should get a nice\ncompile-time warning if a function is missing.","ref":"using_chorex.html"},{"type":"extras","title":"Starting a choreography - Using Chorex","doc":"Invoke `Chorex.start/3` with:\n\n1. The module name of the choreography,\n2. A map from actor name to implementation name, and\n3. A list of initial arguments.\n\nSo, you could start the choreography from the previous section with:\n\n```elixir\nChorex.start(ThreePartySeller.Chorex,\n             %{ Buyer1 => MyBuyer1,\n                Buyer2 => MyBuyer2,\n                Seller => MySeller },\n             [])\n```","ref":"using_chorex.html#starting-a-choreography"},{"type":"extras","title":"Choreography return values - Using Chorex","doc":"Each of the parties will try sending the last value they computed\nonce they're done running. These messages will get set to whatever\nprocess kicked the the choreography off.\n\n```elixir\nChorex.start(ThreePartySeller.Chorex,\n             %{ Buyer1 => MyBuyer1,\n                Buyer2 => MyBuyer2,\n                Seller => MySeller },\n             [])\n\nreceive do\n  {:chorex_return, Buyer1, d_date} -> report_delivery(d_date)\nend\n```","ref":"using_chorex.html#choreography-return-values"},{"type":"extras","title":"Higher-order choreographies - Using Chorex","doc":"Chorex supports higher-order choreographies. For example, you can\ndefine a generic buyer/seller interaction and abstract away the\ndecision process into a higher-order choreography:\n\n```elixir\ndefmodule TestChor3 do\n  defchor [Buyer3, Contributor3, Seller3] do\n    def bookseller(decision_func) do\n      Buyer3.get_book_title() ~> Seller3.the_book\n      with Buyer3.decision <- decision_func.(Seller3.get_price(\"book:\" <> the_book)) do\n        if Buyer3.decision, notify: [Seller3] do\n          Buyer3.get_address() ~> Seller3.the_address\n          Seller3.get_delivery_date(the_book, the_address) ~> Buyer3.d_date\n          Buyer3.d_date\n        else\n          Buyer3.(nil)\n        end\n      end\n    end\n\n    def one_party(Seller3.(the_price)) do\n      Seller3.(the_price) ~> Buyer3.(p)\n      Buyer3.(p   Buyer3.(p)\n      Seller3.(the_price) ~> Contributor3.(p)\n      Contributor3.compute_contrib(p) ~> Buyer3.(contrib)\n      Buyer3.(p - contrib < get_budget())\n    end\n\n    def run(Buyer3.(get_contribution?)) do\n      if Buyer3.(get_contribution?), notify: [Contributor3, Seller3] do\n        bookseller(@two_party/1)\n      else\n        bookseller(@one_party/1)\n      end\n    end\n  end\nend\n```\n\nNotice the `@two_part/1` syntax: the `@` is necessary so Chorex\nknows that this is a reference to a function defined inside the\n`defchor` block; it needs to handle these references specially.\n\nNow, when you start up the choreography, the you can instruct the\nchoreography whether or not to run the three-party scenario. The\nfirst item in the list of arguments will get sent to the node\nrunning the `Buyer3` behaviour and will be used in the decision\nprocess inside the `run` function.\n\n```elixir\nChorex.start(TestChor3.Chorex, %{ ... }, [true])  # run 3-party\nChorex.start(TestChor3.Chorex, %{ ... }, [false]) # run 2-party\n```\n\n### **Experimental** TCP transport setup\n\nYou can run choreographies over TCP. Instead of specifying the\nimplementing module's name in the actor ↦ module map, put a tuple\nlike `{:remote, local_port, remote_host, remote_port}`. A process\nwill begin listening on `local_port` and forward messages to the\nproper actors on the current node. Messages going to a remote actor\nwill be buffered until a TCP connection is established, at which\npoint they'll be sent FIFO.\n\nExample with hosts `alice.net` and `bob.net`:\n\nHost `alice.net`:\n\n```elixir\nChorex.start(BasicRemote.Chorex,\n  %{SockAlice => SockAliceImpl,\n    SockBob => {:remote, 4242, \"bob.net\", 4243}}, [])\n```\n\nHost `bob.net`:\n\n```elixir\nChorex.start(BasicRemote.Chorex,\n  %{SockAlice => {:remote, 4243, \"alice.net\", 4242},\n    SockBob => SockBobImpl}, [])\n```\n\n**WARNING** this transport is *experimental* and not guaranteed to\nwork. We've had issues with message delivery during testing.\nAdditionally, the TCP transport does not play nicely with\n`try/recover` blocks at the moment, though there is no known\nlimitation that would prevent them from working in the future. PRs\nwelcome!","ref":"using_chorex.html#higher-order-choreographies"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}